﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.EJ2.Base;
using WebApplication8.Models;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {
        public static List<OrdersDetails> orders = new List<OrdersDetails>();
        public static List<EmployeeView> emp = new List<EmployeeView>();
        public IActionResult Index()
        {
            emp = EmployeeView.GetAllRecords();
            orders = OrdersDetails.GetAllRecords();
            return View();
        }

        public IActionResult UrlChildDataSource([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = orders;
            DataOperations operation = new DataOperations();
            if(dm.Where != null)
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Condition);
            }
            int count = DataSource.Cast<OrdersDetails>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public IActionResult UrlDatasource([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = emp;
            DataOperations operation = new DataOperations();
            if(dm.Where != null)
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Condition);
            } 
            int count = DataSource.Cast<EmployeeView>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }
        public void batchUpdate([FromBody]ICRUDModel myObject)
        {
            if (myObject.changed != null && myObject.changed.Count > 0)
            {
                foreach (var temp in myObject.changed)
                {
                    var ord = temp;
                    OrdersDetails val = orders.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
                    val.OrderID = ord.OrderID;
                    val.EmployeeID = ord.EmployeeID;
                    val.CustomerID = ord.CustomerID;
                    val.Freight = ord.Freight;
                    val.OrderDate = ord.OrderDate;
                    val.ShipCity = ord.ShipCity;
                    val.ShipName = ord.ShipName;
                }
            }
            if (myObject.added != null && myObject.added.Count > 0)
            {
                foreach (var temp in myObject.added)
                {
                    orders.Insert(0, temp);
                }
            }
            if (myObject.deleted != null && myObject.deleted.Count > 0)
            {
                foreach (var temp in myObject.deleted)
                {
                    orders.Remove(orders.Where(or => or.OrderID == temp.OrderID).FirstOrDefault());
                }
            }

        }
        //public ActionResult Insert([FromBody]ICRUDModel<OrdersDetails> value)
        //{
        //    orders.Insert(0, value.value);
        //    return Json(value.value);
        //}
        //public ActionResult Update([FromBody]ICRUDModel<OrdersDetails> value)
        //{
        //    var ord = value.value;
        //    OrdersDetails val = orders.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
        //    val.OrderID = ord.OrderID;
        //    val.EmployeeID = ord.EmployeeID;
        //    val.CustomerID = ord.CustomerID;
        //    val.Freight = ord.Freight;
        //    val.OrderDate = ord.OrderDate;
        //    val.ShipCity = ord.ShipCity;

        //    return Json(value.value);
        //}
        //public ActionResult Delete([FromBody]ICRUDModel<OrdersDetails> value)
        //{
        //   orders.Remove(orders.Where(or => or.OrderID == int.Parse(value.key.ToString())).FirstOrDefault());
        //    return Json(value);
        //}
        public class ICRUDModel
        {
            public string action { get; set; }

            public string table { get; set; }

            public string keyColumn { get; set; }

            public object key { get; set; }


            public List<OrdersDetails> added { get; set; }

            public List<OrdersDetails> changed { get; set; }

            public List<OrdersDetails> deleted { get; set; }
            
        }
        public IActionResult About()
        {

            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
